/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      return 0;

    case E_SImode:
      if (!nvptx_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      return 1;

    case E_DImode:
      if (!nvptx_register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x2, 1);
  operands[5] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  if (!nvptx_nonmemory_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[0], E_HImode)
          || GET_MODE (x7) != E_HImode
          || !nvptx_register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nvptx_register_operand (operands[0], E_SImode)
          || GET_MODE (x7) != E_SImode
          || !nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!nvptx_register_operand (operands[0], E_DImode)
          || GET_MODE (x7) != E_DImode
          || !nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern46 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!nvptx_register_operand (operands[1], E_BImode))
    return -1;
  return pattern53 (x1); /* [-1, 2] */
}

int
pattern59 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern65 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern73 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  if (!nvptx_register_operand (operands[1], E_BImode))
    return -1;
  switch (GET_CODE (x7))
    {
    case EQ:
      switch (pattern53 (x6))
        {
        case 0:
          return 590; /* *p *selphi_neg_eq */

        case 1:
          return 592; /* *p *selpsi_neg_eq */

        case 2:
          return 594; /* *p *selpdi_neg_eq */

        default:
          return -1;
        }

    case NE:
      switch (pattern53 (x6))
        {
        case 0:
          return 591; /* *p *selphi_neg_ne */

        case 1:
          return 593; /* *p *selpsi_neg_ne */

        case 2:
          return 595; /* *p *selpdi_neg_ne */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
    {
      res = recog_10 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[1] = x4;
  if (!nvptx_float_comparison_operator (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x1, 0);
  operands[4] = x6;
  x7 = XEXP (x6, 0);
  operands[5] = x7;
  x8 = XEXP (x6, 1);
  operands[6] = x8;
  if (!nvptx_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x9 = XEXP (x4, 0);
  operands[2] = x9;
  operands[3] = x5;
  switch (GET_MODE (operands[2]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[2], E_SFmode)
          || !nvptx_nonmemory_operand (operands[3], E_SFmode))
        return -1;
      return 605; /* *p *setcc_intsf */

    case E_DFmode:
      if (!nvptx_register_operand (operands[2], E_DFmode)
          || !nvptx_nonmemory_operand (operands[3], E_DFmode))
        return -1;
      return 606; /* *p *setcc_intdf */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      if (XINT (x4, 1) != 14
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      if (!nvptx_register_operand (operands[0], E_SImode))
        return -1;
      x8 = XVECEXP (x4, 0, 0);
      operands[1] = x8;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      return 716; /* *p oacc_dim_pos */

    case 2:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      x8 = XVECEXP (x4, 0, 0);
      operands[1] = x8;
      x9 = XVECEXP (x4, 0, 1);
      operands[2] = x9;
      switch (XINT (x4, 1))
        {
        case 20:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern64 (x4, 
E_SImode) != 0
                  || !
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
                return -1;
              return 720; /* *p omp_simt_enter_si */

            case E_DImode:
              if (pattern64 (x4, 
E_DImode) != 0
                  || !
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
                return -1;
              return 721; /* *p omp_simt_enter_di */

            default:
              return -1;
            }

        case 4:
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!memory_operand (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode
                  || !nvptx_nonmemory_operand (operands[1], E_SImode))
                return -1;
              if (
#line 2237 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM70))
                return 733; /* *p nvptx_atomic_store_sm70si */
              if (!
#line 2251 "../../gcc/config/nvptx/nvptx.md"
(!TARGET_SM70))
                return -1;
              return 735; /* *p nvptx_atomic_storesi */

            case E_DImode:
              if (!memory_operand (operands[0], E_DImode)
                  || GET_MODE (x4) != E_DImode
                  || !nvptx_nonmemory_operand (operands[1], E_DImode))
                return -1;
              if (
#line 2237 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM70))
                return 734; /* *p nvptx_atomic_store_sm70di */
              if (!
#line 2251 "../../gcc/config/nvptx/nvptx.md"
(!TARGET_SM70))
                return -1;
              return 736; /* *p nvptx_atomic_storedi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
